;vd.bat to assemble.
.386
ideal
model small


macro waitvr
    mov     dx,03DAH             ;
EVEN
@@M2:                              ;
    in       al,dx               ;
    test     al,8                ;
    je       @@M2                  ; Wait until Verticle Retrace Ends
 endm


dataseg
 
 include "multbl1.inc"
 include "sintbl1.inc"
 include "cube3.inc"
 include "paltbl1.inc"
 rotcube dw 1000 dup(0,0,0,0)
 oldirq db 0
 
 cosx dw 0
 sinx dw 0

 cosy dw 0
 siny dw 0

 cosz dw 0
 sinz dw 0
ends

codeseg

proc rotatevox 
        ;Rotate voxels in 3d:stub for ever! 
        ;new vox buffer = si
        ;old vox buffer = di
        ;number of voxels in buffer=cx
        ;cos[xang]=cos[yang]=cos[zang]=gs
        ;sin[xang]=sin[yang]=sin[zang]=fs
        ;dataseg=ds
        
 rotatevoxloop1:                ;main loop(gonna loop cx times)
        shl ecx,16
        mov bx,[si]
        mov cx,[si+2]
        mov bp,[si+4]
        shl edi,16
        shl esi,16
        
        zrotation:
         
         znewx:                 ;=x*cos[a]-y*sin[a] <-\
          mov ax,gs             ;get cos[a]           |
          imul bx               ;*x                   |
          ;mov [cosx],ax
          mov di,ax             ;later...             |
          mov ax,fs             ;get sin[a]           |
          imul cx               ;*y                   |
          sub di,ax             ;---------------------/
         
         znewy:                 ;=x*sin[a]+y*cos[a] <-\
          mov ax,fs             ;get sin[a]           |
          imul bx               ;*x                   |
          
          mov si,ax             ;later...             |
          mov ax,gs             ;get cos[a]           |
          imul cx               ;*y                   |
          add si,ax             ;---------------------/
         
         ;update x and y
         sar di,8       ;di=x
         sar si,8       ;si=y
         
         ;
        ;xrotation:
         
         ;xnewy:                ;y*cos[a]-z*sin[a]<-\
          mov ax,gs             ;get cos[a]         |
          imul si               ;*y                 |
          mov bx,ax             ;                   |
          mov ax,fs             ;get sin[a]         |
          imul bp               ;*z                 |
          sub bx,ax             ;-------------------/
         
         xnewz:                 ;y*sin[a]+z*cos[a] <-\
          mov ax,fs             ;get sin[a]          |
          imul si               ;*y                  |
          mov cx,ax             ;later...            |
          mov ax,gs             ;get cos[a]          |
          imul bp               ;*z                  |
          add cx,ax             ;--------------------/
         
         ;update y and z
         ;sar di,8
         ;mov cx,di
         ;sar si,8
         ;mov bp,si
         
         sar bx,8;bx=y
         sar cx,8 ;cx=z
         ;di=x
         ;mov bp,cx
         ;mov cx,di

         
         
        yrotation:
        
         ;ynewx:                 ;x*cos[a]-z*sin[a]<---\
          mov ax,gs             ;get cos[a]           |
          imul di               ;*x                   |
          mov bp,ax             ;again...             |
          mov ax,fs             ;get sin[a]           |
          imul cx               ;*z                   |
          sub bp,ax             ;---------------------/
         
         ynewz:                  ;x*sin[a]+z*cos[a]<--\
          mov ax,fs             ;get sin[a]           |
          imul di               ;*x                   |
          mov si,ax             ;...                  |
          mov ax,gs             ;get cos[a]           |
          imul cx               ;*z                   |
          add si,ax             ;--------------------/
        
         ;update x, y and z
         mov cx,bx
         mov bx,bp
         sar bx,8
         sar si,8
         mov bp,si
        
        shr edi,16
        shr esi,16
        mov [di],bx
        mov [di+2],cx
        mov [di+4],bp
        ;neg bx
        ;neg cx
        ;neg bp
        ;mov [di+8],bx
        ;mov [di+10],cx
        ;mov [di+12],bp

        add si,6
        add di,8
        shr ecx,16
        dec cx
        jnz rotatevoxloop1
        ret
        

endp rotatevox

proc voxsplot
 ;ds:si=vox buffer
 ;cx=number of voxels to plot
 ;es=vram

 waitvr
 displayloop1:
 shl ecx,16
 xor al,al
 mov di,[si+6]
 mov [es:di],al
 ;stosb

 ;voxtodots     x'=(d*x/(z+d))
 ;              y'=(d*y/(z+d))
 ;d=255                       ;x'=d(x/z)
                              ;y'=d(x/z)
 mov cx,[si+4]          ;get z
 
 add cx,128             ;+d
 jnz v2d1
 inc cx
 v2d1:

 mov ax,[si+2]          ;get y
 shl ax,8               ;*d;alx
 
 cwd
 idiv cx                ;ax=new y
 mov di,ax              ;later...


 mov ax,[si]            ;get x
 shl ax,8               ;*d
 
 cwd
 idiv cx                ;ax=new x
 add di,100
 cmp di,199
 ja a1
 
 cmp di,0
 jl a1
 
 add di,di
 mov di,[multbl1+di]    ;get y*320
 add ax,160
 cmp ax,320
 ja a1
 cmp ax,0
 jl a1
 add di,ax              ;+x
 mov [si+6],di          ;later...
 sub cl,50
 mov al,cl
 mov [es:di],al
 a1:
 add si,8
 shr ecx,16
 loop displayloop1
 ret

proc setpal
 mov ax,@data
 mov es,ax
 mov ax,1012h
 xor bx,bx
 mov cx,0ffh
 lea dx,[paltbl1]
 int 10h
 ret
endp setpal

endp voxsplot

start:
 mov ax,@data
 mov ds,ax
 in      al,21h                  
 ;mov     [oldirq],al             
 ;mov     al,11111111b            
 ;out     21h,al                  
 
 mov ax,0013h
 int 10h

 call setpal
 xor ebx,ebx
 ;cli
 mov ax,0a000h
 mov es,ax
 
 rot3dloop1:
 shr ebx,16
 add bl,1
 add bx,bx
 mov ax,[costbl+bx]
 mov gs,ax

 mov ax,[sintbl+bx]
 mov fs,ax
 shr bx,1
 shl ebx,16


 lea si,[cube3]
 lea di,[rotcube]
 mov cx,550
 call rotatevox
 lea si,[rotcube]
 mov cx,550
 call voxsplot
 in al,60h
 cmp al,1
 jnz rot3dloop1
fin:
;sti
 mov ax,0003h
 int 10h
 ;mov     al,[oldirq]
 ;out     21h,al                  


 mov ah,04ch
 int 21h

end start
